#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last;
    int     result;
    int     test_sequence[20];

    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, "");

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 122 13 14 15 16 17 18 19

    result = accumulate(test_sequence, last, 5);
    cout << result << endl;
    // 195

    result = accumulate(test_sequence, last, 10, plus<int>());
    cout << result << endl;
    // 200
}
