#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int     count_returned;
    int    *last;
    int     test_sequence[20];

    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    count_returned = 0;
    count(test_sequence, last, 9, count_returned);
    cout << count_returned << endl;
    // Output: 1

    count_returned = 0;
    count(test_sequence, last, 20, count_returned);
    cout << count_returned << endl;
    // Output: 0

    count_returned = 0;
    count_if(test_sequence, last, bind2nd(less<int>(), 9), count_returned);
    cout << count_returned << endl;
    // Output: 9

    count_returned = 0;
    count_if(test_sequence, last, bind2nd(greater_equal<int>(), 20),
             count_returned);
    cout << count_returned << endl;
    // Output: 0
}
