#include "algo.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last;
    int     test_sequence[20];

    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    fill(test_sequence, last, 11);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 11 11 11 11 11 11 11 11 11 11 11 11 11 11 11 11 11 11 11 11

    fill_n(test_sequence, (size_t) 10, 20);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 20 20 20 20 20 20 20 20 20 20 11 11 11 11 11 11 11 11 11 11
}
