#include "algo.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last;
    int     test_sequence[20];

    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence, last, IotaGen<int>(10));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29

    generate_n(test_sequence, 10, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 20 21 22 23 24 25 26 27 28 29
}
