#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int     result;
    int     test_sequence1[20];
    int     test_sequence2[22];

    last1 = test_sequence1 + 20;
    last2 = test_sequence2 + 22;

    ostream_iterator<int> out_stream(cout, "");

    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    generate(test_sequence2, last2, IotaGen<int>(2));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23

    result = inner_product(test_sequence1, last1, test_sequence2, 10);
    cout << result << endl;
    // Output: 2860

    result = inner_product(test_sequence1, last1, test_sequence2, 10,
                           plus<int>(), times<int>());
    cout << result << endl;
    // Output: 2860
}
