#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    struct pair<int*, int*>  locations(0,0);
    int    *middle;
    int     test_sequence1[20];
    int     test_sequence2[20];

    middle = test_sequence1 + 10;
    last1 = test_sequence1 + 20;
    last2 = test_sequence2 + 20;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence1, middle, IotaGen<int>(0));
    generate(middle, last1, IotaGen<int>(9));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 9 10 11 12 13 14 15 16 17 18

    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    locations = mismatch(test_sequence1, last1, test_sequence2);
    copy(locations.first, last1, out_stream), cout << endl;
    // Output: 9 10 11 12 13 14 15 16 17 18
    copy(locations.second, last2, out_stream), cout << endl;
    // Output: 10 11 12 13 14 15 16 17 18 19

    locations = mismatch(test_sequence1, last1, test_sequence1);
    copy(locations.first, last1, out_stream), cout << endl;
    // Output:
    copy(locations.second, last1, out_stream), cout << endl;
    // Output:

    locations = mismatch(test_sequence1, last1, test_sequence2,
                         greater_equal<int>());
    copy(locations.first, last1, out_stream), cout << endl;
    // Output: 9 10 11 12 13 14 15 16 17 18
    copy(locations.second, last2, out_stream), cout << endl;
    // Output: 10 11 12 13 14 15 16 17 18 19
}
