#include "algo.h"
#include "iota.h"
#include "random.cpp"  // Can also just compile and link this file

void
main(int argc, char *argv[])

{
    int    *last;
    int     test_sequence[15];

    last = test_sequence + 15;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    random_shuffle(test_sequence, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: (sequence with elements 0 through 14 shuffled into new locations)

    random_shuffle(test_sequence, last, __random_generator(__SEED));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: (sequence with elements 0 through 14 shuffled into new locations)
}
