#include "algo.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *middle;
    int    *new_last2;
    int     test_sequence1[15];
    int     test_sequence2[20];

    last1 = test_sequence1 + 15;
    middle = test_sequence1 + 4;
    last2 = test_sequence2 + 20;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    generate(test_sequence2, last2, IotaGen<int>(20));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39

    rotate(test_sequence1, middle, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 4 5 6 7 8 9 10 11 12 13 14 0 1 2 3


    new_last2 = rotate_copy(test_sequence1, middle, last1, test_sequence2);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 8 9 10 11 12 13 14 0 1 2 3 4 5 6 7 35 36 37 38 39
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 8 9 10 11 12 13 14 0 1 2 3 4 5 6 7
}
