#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last;
    int    *location;
    int    *middle;
    int     test_sequence[20];

    middle = test_sequence + 10;
    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, " ");
    equal_to<int> equals;

    generate(test_sequence, middle, IotaGen<int>(0));
    generate(middle, last, IotaGen<int>(9));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 9 10 11 12 13 14 15 16 17 18

    location = adjacent_find(test_sequence, last);
    copy(location, last, out_stream), cout << endl;
    // Output: 9 9 10 11 12 13 14 15 16 17 18


    location = adjacent_find(test_sequence, last, equals);
    copy(location, last, out_stream), cout << endl;
    // Output: 9 9 10 11 12 13 14 15 16 17 18

    location = adjacent_find(middle, last, equals);
    copy(location, last, out_stream), cout << endl;
    // Output:
}
