#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int     are_equal;
    int    *last1;
    int    *last2;
    int    *middle;
    int     test_sequence1[20];
    int     test_sequence2[25];

    middle = test_sequence1 + 10;
    last1 = test_sequence1 + 20;
    last2 = test_sequence2 + 25;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence1, middle, IotaGen<int>(0));
    generate(middle, last1, IotaGen<int>(9));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 9 10 11 12 13 14 15 16 17 18

    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24

    are_equal = equal(test_sequence1, last1, test_sequence2);
    cout << (are_equal ? "True" : "False") << endl;
    // Output: False

    are_equal = equal(test_sequence1, last1, test_sequence1);
    cout << (are_equal ? "True" : "False") << endl;
    // Output: True

    are_equal = equal(test_sequence1, last1, test_sequence2,
                      greater_equal<int>());
    cout << (are_equal ? "True" : "False") << endl;
    // Output: False
}
