#include "algo.h"
#include "iota.h"

template <class T1>
class Double_Sum {
    public:
        static T1 result;
        Double_Sum() {}
        void operator()(T1 x) { result += x * 2; }
};

int Double_Sum<int>::result = 0;

void
main(void)

{
    int    *last;
    int     test_sequence[20];

    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 122 13 14 15 16 17 18 19

    for_each(test_sequence, last, Double_Sum<int>());
    cout << Double_Sum<int>::result << endl;
    // Output: 380
}
