#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int     a = 4;
    int     b = 5;
    int     c;
    int    *last;
    int    *location;
    int     test_sequence[20];

    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, " ");
    less<int> less_than;

    cout << a << ' ' << b << endl;
    // Output: 4 5

    c = min(a, b);
    cout << c << endl;
    // Output : 4

    c = min(a, b, less_than);
    cout << c << endl;
    // Output : 4


    c = max(a, b);
    cout << c << endl;
    // Output : 5

    c = max(a, b, less_than);
    cout << c << endl;
    // Output : 5


    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    location = max_element(test_sequence, last);
    copy(location, last, out_stream), cout << endl;
    // Output: 19

    location = max_element(last, last);
    copy(location, last, out_stream), cout << endl;
    // Output:

    location = max_element(test_sequence, last, less_than);
    copy(location, last, out_stream), cout << endl;
    // Output: 19


    location = min_element(test_sequence, last);
    copy(location, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    location = min_element(last, last);
    copy(location, last, out_stream), cout << endl;
    // Output:

    location = min_element(test_sequence, last, less_than);
    copy(location, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19
}
